/*
 * #LICENSE%
 * BielefeldTypeLibrary
 * ---
 * Copyright (C) 2009 - 2013 Frederic Siepmann
 * ---
 * This file is part of Bielefeld Type Library (BTL).
 * 
 * http://opensource.cit-ec.de/projects/btl
 * 
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 * 
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 * 
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 * 
 * Contributors: Florian Lier, Frederic Siepmann, Leon Ziegler, Matthias 
 * Schoepfer, Adriana-Victoria Dreyer, Agnes Swadzba, Andreas Kipp, Birte 
 * Carlmeyer, Christian Ascheberg, Daniel Nacke, Dennis Wigand, Günes Minareci, 
 * Hendrik ter Horst, Ingo Killmann, Jan Pöppel, Lukas Kettenbach, Michael 
 * Zeunert, Patrick Renner, Philipp Dresselhaus, Sebastian Meyer zu Borgsen, 
 * Soufian Jebbara, Tobias Röhlig, Torben Toeniges, Viktor Losing, Viktor Richter
 * %LICENSE#
 */

/*
 * ROSDynamicConfiguration.h
 *
 *  Created on: May 31, 2012
 *      Author: pdressel
 */

#ifndef ROSDYNAMICCONFIGURATION_H_
#define ROSDYNAMICCONFIGURATION_H_

#include <string>
#include <xmltio/xmltio.hpp>
#include "../../Type.h"

namespace airobots
{
    
class ROSDynamicConfiguration : public Type
{
    
public:
   
    static const std::string X_PATH_SEPARATOR;
    static const std::string ATTRIBUTE_PREFIX;
    static const std::string TRUE_STRING;
    static const std::string FALSE_STRING;
    
    ROSDynamicConfiguration() {};
    virtual ~ROSDynamicConfiguration() {};
    static std::string getBaseTag();

    void sanitizeLocation(xmltio::Location &loc) const;
   
private:
    static const std::string BASETAG;
};
    
}

#endif /* ROSDYNAMICCONFIGURATION_H_ */
