/*
 * #LICENSE%
 * BielefeldTypeLibrary
 * ---
 * Copyright (C) 2009 - 2013 Frederic Siepmann
 * ---
 * This file is part of Bielefeld Type Library (BTL).
 * 
 * http://opensource.cit-ec.de/projects/btl
 * 
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 * 
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 * 
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 * 
 * Contributors: Florian Lier, Frederic Siepmann, Leon Ziegler, Matthias 
 * Schoepfer, Adriana-Victoria Dreyer, Agnes Swadzba, Andreas Kipp, Birte 
 * Carlmeyer, Christian Ascheberg, Daniel Nacke, Dennis Wigand, Günes Minareci, 
 * Hendrik ter Horst, Ingo Killmann, Jan Pöppel, Lukas Kettenbach, Michael 
 * Zeunert, Patrick Renner, Philipp Dresselhaus, Sebastian Meyer zu Borgsen, 
 * Soufian Jebbara, Tobias Röhlig, Torben Toeniges, Viktor Losing, Viktor Richter
 * %LICENSE#
 */

/*
 * utils.h
 *
 *  Created on: Aug 17, 2009
 *      Author: jwienke
 */

#ifndef UTILS_H_
#define UTILS_H_

#include <string>
#include <fstream>

#include <boost/test/unit_test.hpp>

/**
 * Reads a text file to a string.
 *
 * @param filename name of the file relative to the test root.
 */
inline std::string readFile(std::string filename) {

	int argc = boost::unit_test::framework::master_test_suite().argc;
	char** argv = boost::unit_test::framework::master_test_suite().argv;

	if (argc < 2) {
		BOOST_FAIL(
				"No location for resources given. First argument must be the location of resources.");
	}
	std::string root(argv[1]);

	std::string realFileName = root + "/" + filename;
	std::ifstream file(realFileName.c_str());
	if (!file) {
		BOOST_FAIL("Unable to read file " + realFileName);
	}

	std::string contents;
	std::string token;
	getline(file, token);
	while (file) {
		contents += token;
		getline(file, token);
	}

	file.close();

	return contents;

}

#endif /* UTILS_H_ */
